#include	"mimeatr.h"

#define	VER		"ver.0.00"
#define	DATE	"2005.1.16"


int main()
{
	mimeatr	app;
	app.Run();
	return(0);
}
//------------------------------------------------
mimeatr::mimeatr():BApplication("application/x-vnd.Beer-mimeatr")
{
	BRect	frame;
	frame.Set(100,100,499,399);
	w=new mimeatrwindow(frame);
}

void mimeatr::MessageReceived(BMessage *msg)
{
	switch(msg->what){
		default:{
			BApplication::MessageReceived(msg);
		}break;
	}
}

void mimeatr::AboutRequested()
{ 
	BAlert *alert;
	alert=new BAlert("",
		"mimeatr "VER"   "DATE"\n"
		"    copyright Hiroyuki Tsutsumi\n\n"
		" E-mail : gch07232@nifty.ne.jp\n"
		"   HP   : http://www.eonet.ne.jp/~hirotsu/"
	,"Thank you");
	alert->Go();
} 
//------------------------------------------------
mimeatrwindow::mimeatrwindow(BRect frame):BWindow(frame,"mimeatr "VER,B_DOCUMENT_WINDOW,0)
{
	BRect	viewframe;
	viewframe.Set(0,0,frame.Width(),frame.Height()-20);
	viewframe.OffsetTo(0,20);
	v=new mimeatrview(viewframe);
	AddChild(v);
	setupmenus();
	Show();
}

bool mimeatrwindow::QuitRequested()
{
	BMessenger(be_app).SendMessage(B_QUIT_REQUESTED);	//be_app->PostMessage(B_QUIT_REQUESTED);
	return(true);
}

void mimeatrwindow::setupmenus()
{
	BMenuBar	*mb;
	BMenu		*m;
	BMenuItem	*mi;
//	BMessage	*mes;
	mb=new BMenuBar(BRect(0,0,20,20),"menubar");
	m=new BMenu(_T("File"));
	 mi=new BMenuItem(_T("About"),new BMessage(B_ABOUT_REQUESTED));
	 mi->SetTarget((BHandler*)be_app);
	 m->AddItem(mi);
	 mi=new BMenuItem(_T("Quit"),new BMessage(B_QUIT_REQUESTED));
	 mi->SetTarget((BHandler*)be_app);
	 m->AddItem(mi);
	mb->AddItem(m);
	AddChild(mb);
}
//------------------------------------------------
mimeatrview::mimeatrview(BRect frame):BView(frame,"mimeatr_v",B_FOLLOW_ALL_SIDES,B_WILL_DRAW)
{
	strcpy(mime,"");
	atrid=-1;
}

mimeatrview::~mimeatrview()
{
}

void mimeatrview::AttachedToWindow()
{
	SetHighColor(0,0,0);
	SetViewColor(200,200,220);
	SetLowColor(150,150,165);
	SetFont(be_plain_font);

	BMessage	*ms;

	BMimeType	mt;
	BMessage	mm;
	mt.GetInstalledTypes(&mm);
	BPopUpMenu	*m;
	BMenuItem	*mi;
	m=new BPopUpMenu("select !");
	for(int i=0;;i++){
		const char	*s;
		if(mm.FindString("types",i,&s))break;
		ms=new BMessage('Msel');
		ms->AddString("mime",s);
		mi=new BMenuItem(_T(s),ms);
		mi->SetTarget(this);
		m->AddItem(mi);
	}
	mf=new BMenuField(BRect(20,20,370,50),"mf","mimetype",m);
	mf->SetDivider(100);
	AddChild(mf);

	lv=new BListView(BRect(20,70,150,220),"attr-list");
	ms=new BMessage('Asel');
	lv->SetSelectionMessage(ms);
	lv->SetTarget(this);
	AddChild(lv);

	ms=new BMessage('Vchg');
	tc0=new BTextControl(BRect(20,240,150,260),"newatr",NULL,"",ms);
	tc0->SetTarget(this);
	tc0->Hide();
	AddChild(tc0);

	ms=new BMessage('Vchg');
	tc1=new BTextControl(BRect(170,70,370,100),"name","attribute name","",ms);
	tc1->SetTarget(this);
	AddChild(tc1);

	ms=new BMessage('Vchg');
	tc2=new BTextControl(BRect(170,100,370,130),"type","attribute type","",ms);
	tc2->SetTarget(this);
	AddChild(tc2);

	ms=new BMessage('Vchg');
	tc3=new BTextControl(BRect(170,130,370,160),"width","width","",ms);
	tc3->SetTarget(this);
	AddChild(tc3);

	ms=new BMessage('Vchg');
	tc4=new BTextControl(BRect(170,160,370,190),"alignment","alignment","",ms);
	tc4->SetTarget(this);
	AddChild(tc4);

	ms=new BMessage('Vchg');
	cb1=new BCheckBox(BRect(170,190,240,220),"viewable","viewable",ms);
	cb1->SetTarget(this);
	AddChild(cb1);

	ms=new BMessage('Vchg');
	cb2=new BCheckBox(BRect(240,190,310,220),"editable","editable",ms);
	cb2->SetTarget(this);
	AddChild(cb2);

	ms=new BMessage('Vchg');
	cb3=new BCheckBox(BRect(310,190,380,220),"extra","extra",ms);
	cb3->SetTarget(this);
	AddChild(cb3);

	ms=new BMessage('Aadd');
	pb1=new BButton(BRect(20,240,70,260),"add","add",ms);
	pb1->SetTarget(this);
	AddChild(pb1);

	ms=new BMessage('Adel');
	pb2=new BButton(BRect(100,240,150,260),"del","del",ms);
	pb2->SetTarget(this);
	AddChild(pb2);

	ms=new BMessage('Mcan');
	pb3=new BButton(BRect(250,240,300,260),"cansel","cansel",ms);
	pb3->SetTarget(this);
	AddChild(pb3);

	ms=new BMessage('Mset');
	pb4=new BButton(BRect(320,240,370,260),"set","set",ms);
	pb4->SetTarget(this);
	AddChild(pb4);

	MakeFocus();
}

void mimeatrview::Draw(BRect rect)
{
	DrawString("public name",BPoint(20,65));
	StrokeRect(BRect(19,69,151,221));
}

void mimeatrview::MessageReceived(BMessage *msg)
{
//msg->PrintToStream();
	switch(msg->what){
		case 'Msel':{	//select mime
			addatrmode(false);
			const char	*s;
			if(!msg->FindString("mime",&s)){
				strcpy(mime,s);
				getmimeatr();
				setatrlist();
			}
		}break;
		case 'Mcan':{	//cansel
			addatrmode(false);
			getmimeatr();
			setatrlist();
		}break;
		case 'Mset':{	//check & write
			setmimeatr();
		}break;
		case 'Asel':{	//select attribute
			if(!tc0->IsHidden()){	//new attribute
				int32	i;
				int	c=lv->CountItems()-1;
				if(!msg->FindInt32("index",&i)){
					if(i!=c)lv->Select(c);
				}
				break;
			}
			addatrmode(false);
			int32	i;
			if(!msg->FindInt32("index",&i)){
				atrid=i;
				setatrview();
			}
		}break;
		case 'Aadd':{	//new attribute
			addatrmode(true);
			addnewatr();
		}break;
		case 'Adel':{	//remove attribute
			mimeatr.RemoveData("attr:public_name",atrid);
			mimeatr.RemoveData("attr:name",atrid);
			mimeatr.RemoveData("attr:type",atrid);
			mimeatr.RemoveData("attr:width",atrid);
			mimeatr.RemoveData("attr:alignment",atrid);
			mimeatr.RemoveData("attr:viewable",atrid);
			mimeatr.RemoveData("attr:editable",atrid);
			mimeatr.RemoveData("attr:extra",atrid);
			setatrlist();
			setatrview();
		}break;
		case 'Vchg':{
			void	*from;
			if(msg->FindPointer("source",&from))break;
			if(from==tc0){
				mimeatr.ReplaceString("attr:public_name",atrid,tc0->Text());
				setatrlist();
				addatrmode(false);
				lv->Select(lv->CountItems()-1);
			}else if(from==tc1){
				mimeatr.ReplaceString("attr:name",atrid,tc1->Text());
			}else if(from==tc2){
				uchar	*t=(uchar*)(tc2->Text());
				int32	i32=t[0]<<24|t[1]<<16|t[2]<<8|t[3];
				mimeatr.ReplaceInt32("attr:type",atrid,i32);
			}else if(from==tc3){
				int32	i32;
				sscanf(tc3->Text(),"%d",&i32);
				mimeatr.ReplaceInt32("attr:width",atrid,i32);
			}else if(from==tc4){
				int32	i32;
				sscanf(tc4->Text(),"%d",&i32);
				mimeatr.ReplaceInt32("attr:alignment",atrid,i32);
			}else if(from==cb1){
				mimeatr.ReplaceBool("attr:viewable",atrid,cb1->Value());
			}else if(from==cb2){
				mimeatr.ReplaceBool("attr:editable",atrid,cb2->Value());
			}else if(from==cb3){
				mimeatr.ReplaceBool("attr:extra",atrid,cb3->Value());
			}
		}break;
		default:{
			BView::MessageReceived(msg);
		}break;
	}
}

void mimeatrview::setmimeatr()
{
	mimeatr.RemoveName("type");		//
	BMimeType	mm(mime);
	mm.SetAttrInfo(&mimeatr);
}

void mimeatrview::getmimeatr()
{
	BMimeType	mm(mime);
	if(mm.GetAttrInfo(&mimeatr))mimeatr=BMessage();
}

void mimeatrview::addnewatr()
{
	mimeatr.AddString("attr:public_name","New Attribute");
	mimeatr.AddString("attr:name","Meta:");
	mimeatr.AddInt32("attr:type",'CSTR');
	mimeatr.AddInt32("attr:width",100);
	mimeatr.AddInt32("attr:alignment",0);
	mimeatr.AddBool("attr:viewable",true);
	mimeatr.AddBool("attr:editable",true);
	mimeatr.AddBool("attr:extra",false);

	setatrlist();
	atrid=lv->CountItems()-1;
	lv->Select(atrid);
	setatrview();
}

void mimeatrview::setatrlist()
{
	//clear attr-list
	BListItem	*t;
	while((t=lv->LastItem())){lv->RemoveItem(t);delete t;}
	atrid=-1;

	for(int i=0;;i++){
		const char	*str;
		if(mimeatr.FindString("attr:public_name",i,&str))break;
		BStringItem	*si=new BStringItem(str);
		lv->AddItem(si);
	}
}

void mimeatrview::setatrview()
{
	tc0->SetText("");
	tc1->SetText("");
	tc2->SetText("");
	tc3->SetText("");
	tc4->SetText("");
	cb1->SetValue(0);
	cb2->SetValue(0);
	cb3->SetValue(0);

	const char	*str;
	int32	i32;
	bool	b;
	if(!mimeatr.FindString("attr:name",atrid,&str))tc1->SetText(str);
	if(!mimeatr.FindInt32("attr:type",atrid,&i32)){
		char	c4[5];
		sprintf(c4,"%c%c%c%c",i32>>24,i32>>16,i32>>8,i32);
		tc2->SetText(c4);
	}
	if(!mimeatr.FindInt32("attr:width",atrid,&i32)){
		char	d1[10];
		sprintf(d1,"%d",i32);
		tc3->SetText(d1);
	}
	if(!mimeatr.FindInt32("attr:alignment",atrid,&i32)){
		char	d2[10];
		sprintf(d2,"%d",i32);
		tc4->SetText(d2);
	}
	if(!mimeatr.FindBool("attr:viewable",atrid,&b))cb1->SetValue(b);
	if(!mimeatr.FindBool("attr:editable",atrid,&b))cb2->SetValue(b);
	if(!mimeatr.FindBool("attr:extra",atrid,&b))cb3->SetValue(b);
}

void mimeatrview::addatrmode(bool f)
{
	if(f){
		while(!pb1->IsHidden())pb1->Hide();
		while(!pb2->IsHidden())pb2->Hide();
		pb4->SetEnabled(false);
		mf->SetEnabled(false);
		while(tc0->IsHidden())tc0->Show();
		tc0->MakeFocus();
	}else{
		while(!tc0->IsHidden())tc0->Hide();
		while(pb1->IsHidden())pb1->Show();
		while(pb2->IsHidden())pb2->Show();
		pb4->SetEnabled(true);
		mf->SetEnabled(true);
	}
}
